unit Unit1;

interface

uses
  Windows, Forms, StdCtrls, Menus, Dialogs, ImgList, Controls, StdActns,
  ExtActns, Classes, ActnList, ExtCtrls, ComCtrls, ToolWin, XPMan,
  MWKEdit;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    ImageList1: TImageList;
    RichEditBold1: TRichEditBold;
    RichEditItalic1: TRichEditItalic;
    RichEditUnderline1: TRichEditUnderline;
    RichEditStrikeOut1: TRichEditStrikeOut;
    SpacedAction1: TAction;
    IndexAction1: TAction;
    SuperAction1: TAction;
    SubAction1: TAction;
    ShowTagsAction1: TAction;
    ClearAction1: TAction;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditDelete1: TEditDelete;
    SpellAction1: TAction;
    FileOpen1: TFileOpen;
    NewAction1: TAction;
    StatusBar1: TStatusBar;
    SaveAction1: TAction;
    SaveDialog1: TSaveDialog;
    QuitAction1: TAction;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Bearbeiten1: TMenuItem;
    Format1: TMenuItem;
    Extras1: TMenuItem;
    Ansicht1: TMenuItem;
    Neu1: TMenuItem;
    ffnen1: TMenuItem;
    Speichern1: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Kopieren1: TMenuItem;
    Ausschneiden1: TMenuItem;
    Einfgen1: TMenuItem;
    Allesmarkieren1: TMenuItem;
    Lschen1: TMenuItem;
    Markierungentfernen1: TMenuItem;
    N2: TMenuItem;
    Steuerzeichenanzeigen1: TMenuItem;
    Rechtschreibung1: TMenuItem;
    FontEdit1: TFontEdit;
    Schriftartwhlen1: TMenuItem;
    ShowSpellAction1: TAction;
    Rechtschreibfehleranzeigen1: TMenuItem;
    SelectSpellAction1: TAction;
    Sprachewhlen1: TMenuItem;
    MWKEdit1: TMWKEdit;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton25: TToolButton;
    ToolButton26: TToolButton;
    ToolButton36: TToolButton;
    ToolButton37: TToolButton;
    ToolButton38: TToolButton;
    ToolButton39: TToolButton;
    ToolButton40: TToolButton;
    ToolButton41: TToolButton;
    ToolButton42: TToolButton;
    ToolButton43: TToolButton;
    ToolBar2: TToolBar;
    ToolButton49: TToolButton;
    ToolButton50: TToolButton;
    ToolButton51: TToolButton;
    ToolButton52: TToolButton;
    ToolButton53: TToolButton;
    ToolButton54: TToolButton;
    ToolButton55: TToolButton;
    ToolButton56: TToolButton;
    ToolButton66: TToolButton;
    FontName: TComboBox;
    FontSize: TComboBox;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ColorBox2: TColorBox;
    ColorBox1: TColorBox;
    ToolButton3: TToolButton;
    Label1: TLabel;
    Label2: TLabel;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    RedoAction1: TAction;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N3: TMenuItem;
    UndoAction1: TAction;
    procedure RedoAction1Execute(Sender: TObject);
    procedure UndoAction1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MWKEdit1SelectionChange(Sender: TObject);
    procedure MWKEdit1ToggleInsert(Sender: TObject);
    procedure RichEditBold1Execute(Sender: TObject);
    procedure RichEditItalic1Execute(Sender: TObject);
    procedure RichEditUnderline1Execute(Sender: TObject);
    procedure RichEditStrikeOut1Execute(Sender: TObject);
    procedure SpacedAction1Execute(Sender: TObject);
    procedure IndexAction1Execute(Sender: TObject);
    procedure SuperAction1Execute(Sender: TObject);
    procedure SubAction1Execute(Sender: TObject);
    procedure ShowTagsAction1Execute(Sender: TObject);
    procedure ClearAction1Execute(Sender: TObject);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure EditSelectAll1Execute(Sender: TObject);
    procedure EditDelete1Execute(Sender: TObject);
    procedure SpellAction1Execute(Sender: TObject);
    procedure NewAction1Execute(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure SaveAction1Execute(Sender: TObject);
    procedure StatusBar1DblClick(Sender: TObject);
    procedure QuitAction1Execute(Sender: TObject);
    procedure FontEdit1Accept(Sender: TObject);
    procedure FontEdit1BeforeExecute(Sender: TObject);
    procedure ShowSpellAction1Execute(Sender: TObject);
    procedure SelectSpellAction1Execute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure FontSizeKeyPress(Sender: TObject; var Key: Char);
    procedure ColorBox1Change(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
  private
    FUpdating: Boolean;
    procedure ReadFontNames;
    procedure UpdateUndoRedo;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses
  Graphics, SysUtils,
  MWKSysUtils, Unit2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ReadFontNames;
  MWKEdit1.Dictionary := 0;
  if MWKEdit1.Dictionary >= 0 then
    StatusBar1.Panels[2].Text := 'Sprache: ' + MWKEdit1.Dictionaries[MWKEdit1.Dictionary]
  else
    StatusBar1.Panels[2].Text := 'Sprache: ';
  SpellAction1.Enabled := MWKEdit1.Dictionary >= 0;

  FontName.ItemIndex := FontName.Items.IndexOf(MWKEdit1.FontName);
  FontSize.Text := FloatToStr(MWKEdit1.FontSize);
end;

procedure TForm1.MWKEdit1SelectionChange(Sender: TObject);
begin
  FUpdating := True;
  RichEditBold1.Checked := MWKEdit1.Bold;
  RichEditItalic1.Checked := MWKEdit1.Italic;
  RichEditUnderline1.Checked := MWKEdit1.Underline;
  RichEditStrikeOut1.Checked := MWKEdit1.StrikeOut;
  SpacedAction1.Checked := MWKEdit1.Spaced;
  IndexAction1.Checked := MWKEdit1.Index;
  FontName.ItemIndex := FontName.Items.IndexOf(MWKEdit1.FontName);
  FontSize.Text := FloatToStr(MWKEdit1.FontSize);
  if MWKEdit1.Super then
    SuperAction1.Checked := True
  else
    if MWKEdit1.Sub then
      SubAction1.Checked := True
    else
      begin
        SuperAction1.Checked := False;
        SubAction1.Checked := False;
      end;
  FUpdating := False;
  StatusBar1.Panels[0].Text := 'Zeile ' + IntToStr(MWKEdit1.CurrentLine);
  UpdateUndoRedo;
end;

procedure TForm1.MWKEdit1ToggleInsert(Sender: TObject);
begin
  if MWkEdit1.InsertState = isInsert then
    StatusBar1.Panels[1].Text := 'Einfgen'
  else
    StatusBar1.Panels[1].Text := 'berschreiben';
end;

procedure TForm1.RichEditBold1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.Bold := RichEditBold1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.RichEditItalic1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.Italic := RichEditItalic1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.RichEditUnderline1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.Underline := RichEditUnderline1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.RichEditStrikeOut1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.StrikeOut := RichEditStrikeOut1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.SpacedAction1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.Spaced := SpacedAction1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.IndexAction1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWkEdit1.Index := IndexAction1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.SuperAction1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  if (MWKEdit1.Super and SuperAction1.Checked) then
    MWKEdit1.Super := False
  else
    MWKEdit1.Super := SuperAction1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.UndoAction1Execute(Sender: TObject);
begin
  MWKEdit1.Undo;
end;

procedure TForm1.UpdateUndoRedo;
begin
  UndoAction1.Caption := 'Rckgngig: ' + MWKEdit1.UndoText;
  UndoAction1.Hint := UndoAction1.Caption;
  RedoAction1.Caption := 'Wiederherstellen: ' + MWKEdit1.RedoText;
  RedoAction1.Hint := RedoAction1.Caption;
  UndoAction1.Enabled := MWKEdit1.CanUndo;
  RedoAction1.Enabled := MWKEdit1.CanRedo;
end;

procedure TForm1.SubAction1Execute(Sender: TObject);
begin
  if FUpdating then
    Exit;
  if (MWKEdit1.Sub and SubAction1.Checked) then
    MWKEdit1.Sub := False
  else
    MWKEdit1.Sub := SubAction1.Checked;
  UpdateUndoRedo;
end;

procedure TForm1.ShowTagsAction1Execute(Sender: TObject);
begin
  MWKEdit1.ShowTags := ShowTagsAction1.Checked;
end;

procedure TForm1.RedoAction1Execute(Sender: TObject);
begin
  MWKEdit1.Redo;
end;

procedure TForm1.ClearAction1Execute(Sender: TObject);
begin
  MWKEdit1.ClearSelection;
end;

procedure TForm1.EditCut1Execute(Sender: TObject);
begin
  MWKEdit1.CutToClipboard;
  UpdateUndoRedo;
end;

procedure TForm1.EditCopy1Execute(Sender: TObject);
begin
  MWKEdit1.CopyToClipboard;
  UpdateUndoRedo;
end;

procedure TForm1.EditPaste1Execute(Sender: TObject);
begin
  MWKEdit1.PasteFromClipboard;
  UpdateUndoRedo;
end;

procedure TForm1.EditSelectAll1Execute(Sender: TObject);
begin
  MWKEdit1.SelectAll;
end;

procedure TForm1.EditDelete1Execute(Sender: TObject);
begin
  MWKEdit1.SelectedText := '';
  UpdateUndoRedo;
end;

procedure TForm1.SpellAction1Execute(Sender: TObject);
begin
  MWKEdit1.SpellCheckAll;
  UpdateUndoRedo;
end;

procedure TForm1.NewAction1Execute(Sender: TObject);
begin
  MWKEdit1.Clear;
  MWKEdit1.FontColor := clBlack;
  MWKEdit1.Bold := False;
  MWKEdit1.Italic := False;
  MWKEdit1.Underline := False;
  MWKEdit1.StrikeOut := False;
  MWKEdit1.Spaced := False;
  MWKEdit1.Super := False;
  MWKEdit1.Sub := False;
  MWKEdit1.Index := False;
  MWKEdit1.OnSelectionChange(nil);
end;

procedure TForm1.FileOpen1Accept(Sender: TObject);
var
  Ok: Integer;
  Ext: WideString;
begin
  Screen.Cursor := crHourGlass;
  Ext := LowerCaseW(ExtractFileExt(FileOpen1.Dialog.FileName));
  try
    if (Ext = '.txt') or (Ext = '.xml') or (Ext = '.rtf') then
      Ok := MWKEdit1.LoadFromFile(FileOpen1.Dialog.FileName)
    else
      Ok := MWKEdit1.LoadFromMSWord(FileOpen1.Dialog.FileName);
  finally
    Screen.Cursor := crDefault;
  end;
  case Ok of
    1: ShowMessage('Fehler beim Lesen der Datei.');

    2: ShowMessage('Dieses Dokument bentigt Microsoft Word.');
  end;
end;

procedure TForm1.SaveAction1Execute(Sender: TObject);
var
  FileFormat: TFileFormat;
begin
  if SaveDialog1.Execute then
  try
    Screen.Cursor := crHourGlass;
    FileFormat := ffXML;
    case SaveDialog1.FilterIndex of
      1: FileFormat := ffXML;
      2: FileFormat := ffRTF;
      3: FileFormat := ffUnicode;
      4: FileFormat := ffAnsi;
    end;
    MWKEdit1.SaveToFile(SaveDialog1.FileName, FileFormat);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.StatusBar1DblClick(Sender: TObject);
var
  Point: TPoint;
  Res: Integer;
begin
  Point := StatusBar1.ScreenToClient(Mouse.CursorPos);
  if (Point.X >= StatusBar1.Panels[0].Width + StatusBar1.Panels[1].Width) and
     (Point.X < StatusBar1.Panels[0].Width + StatusBar1.Panels[1].Width +
      StatusBar1.Panels[2].Width) then
  begin
    Form2.FillDictionaries(MWKEdit1.Dictionaries, MWKEdit1.Dictionary);
    Res := Form2.Execute;
    if Res <> - 1 then
    begin
      MWKEdit1.Dictionary := Res;
      if MWKEdit1.Dictionary >= 0 then
        StatusBar1.Panels[2].Text := 'Sprache: ' + MWKEdit1.Dictionaries[MWKEdit1.Dictionary]
      else
        StatusBar1.Panels[2].Text := 'Sprache: ';
      SpellAction1.Enabled := MWKEdit1.Dictionary >= 0;
    end;
  end;
end;

procedure TForm1.QuitAction1Execute(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FontEdit1Accept(Sender: TObject);
begin
  MWKEdit1.BeginUpdate;
  MWKEdit1.FontName := FontEdit1.Dialog.Font.Name;
  MWKEdit1.FontHeight := FontEdit1.Dialog.Font.Height;
  MWKEdit1.Bold := fsBold in FontEdit1.Dialog.Font.Style;
  MWKEdit1.Italic := fsItalic in FontEdit1.Dialog.Font.Style;
  MWKEdit1.Underline := fsUnderline in FontEdit1.Dialog.Font.Style;
  MWKEdit1.StrikeOut := fsStrikeOut in FontEdit1.Dialog.Font.Style;
  MWKEdit1.FontColor := FontEdit1.Dialog.Font.Color;
  MWKEdit1.EndUpdate(True);
  MWKEdit1SelectionChange(nil);
end;

procedure TForm1.FontEdit1BeforeExecute(Sender: TObject);
begin
  FontEdit1.Dialog.Font.Name := MWKEdit1.FontName;
  FontEdit1.Dialog.Font.Height := Round(MWKEdit1.FontHeight);
  FontEdit1.Dialog.Font.Color := MWKEdit1.FontColor;
  FontEdit1.Dialog.Font.Style := [];
  if MWKEdit1.Bold then
    FontEdit1.Dialog.Font.Style := FontEdit1.Dialog.Font.Style + [fsBold];
  if MWKEdit1.Italic then
    FontEdit1.Dialog.Font.Style := FontEdit1.Dialog.Font.Style + [fsItalic];
  if MWKEdit1.Underline then
    FontEdit1.Dialog.Font.Style := FontEdit1.Dialog.Font.Style + [fsUnderline];
  if MWKEdit1.StrikeOut then
    FontEdit1.Dialog.Font.Style := FontEdit1.Dialog.Font.Style + [fsStrikeOut];
end;

procedure TForm1.ShowSpellAction1Execute(Sender: TObject);
begin
  MWKEdit1.ShowSpellErrors := ShowSpellAction1.Checked;
end;

procedure TForm1.SelectSpellAction1Execute(Sender: TObject);
var
  Res: Integer;
begin
  Form2.FillDictionaries(MWKEdit1.Dictionaries, MWKEdit1.Dictionary);
  Res := Form2.Execute;
  if Res <> - 1 then
  begin
    MWKEdit1.Dictionary := Res;
    if MWKEdit1.Dictionary >= 0 then
      StatusBar1.Panels[2].Text := 'Sprache: ' + MWKEdit1.Dictionaries[MWKEdit1.Dictionary]
    else
      StatusBar1.Panels[2].Text := 'Sprache: ';
    SpellAction1.Enabled := MWKEdit1.Dictionary >= 0;
  end;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TForm1.ReadFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MWKEdit1.SetFocus;
end;

procedure TForm1.FontNameChange(Sender: TObject);
begin
  if FUpdating then
    Exit;
  MWKEdit1.FontName := FontName.Text;
  MWKEdit1.SetFocus;
  UpdateUndoRedo;
end;

procedure TForm1.FontSizeChange(Sender: TObject);
begin
  if FUpdating then
    Exit;

  MWKEdit1.FontSize := StrToInt(FontSize.Text);
  MWKEdit1.SetFocus;
end;

procedure TForm1.FontSizeKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9']) then
    Key := #0;
end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
  MWkEdit1.FontColor := ColorBox1.Selected;
  MWKEdit1.SetFocus;
  UpdateUndoRedo;
end;

procedure TForm1.ColorBox2Change(Sender: TObject);
begin
  MWkEdit1.BackgroundColor := ColorBox2.Selected;
  MWKEdit1.SetFocus;
  UpdateUndoRedo;
end;

end.
