unit MWKEditPropEditors;

interface

uses
  MWKEdit;

procedure Register;

implementation

uses
  Classes, DesignIntf, DesignEditors;

type
  TSpellCheckerProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

procedure Register;
begin
  RegisterPropertyEditor(
   TypeInfo(TSpellChecker), TMWKEdit, 'SpellChecker', TSpellCheckerProperty);
end;

{ TSpellCheckerProperty }

function TSpellCheckerProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList];
end;

procedure TSpellCheckerProperty.GetValueList(List: TStrings);
var
  SCL: TSpellCheckerList;
  C: Integer;
begin
  List.Clear;

  SCL := GetSpellCheckers;


  if Assigned(SCL) then
    for C := 0 to SCL.Count - 1 do
      List.Add(SCL.GetName(C));
end;

procedure TSpellCheckerProperty.GetValues(Proc: TGetStrProc);
var 
  C: Integer;
  Values: TStringList; 
begin 
  Values := TStringList.Create; 
  try 
    GetValueList(Values); 
    for C := 0 to Pred(Values.Count) do
      Proc(Values[C]); 
  finally 
    Values.Free; 
  end; 
end;

end.
