unit SpellCheckDialog;
      {******************************************************************}
      { SpellCheckDialog                                                 }
      {                                                                  }
      { home page : http://www.mwcs.de                                   }
      { email     : martin.walter@mwcs.de                                }
      {                                                                  }
      { date      : 09-03-2006                                           }
      { version   : v1.0                                                 }
      {                                                                  }
      { Use of this file is permitted for commercial and non-commercial  }
      { use, as long as the original author is credited.                 }
      { This file (c) 2005, 2006 Martin Walter                           }
      {                                                                  }
      { This Software is distributed on an "AS IS" basis, WITHOUT        }
      { WARRANTY OF ANY KIND, either express or implied.                 }
      {                                                                  }
      { *****************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TSpellCheckForm = class(TForm)
    Edit: TEdit;
    Box: TListBox;
    ChangeButton: TButton;
    AddButton: TButton;
    CancelButton: TButton;
    IgnoreButton: TButton;
    IgnoreAllButton: TButton;
    procedure EditChange(Sender: TObject);
    procedure BoxClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BoxDblClick(Sender: TObject);
  private
    FLastWasEdit: Boolean;
  public
    procedure Init(const Word: WideString);
    procedure Add(const Word: WideString);
    function Replacer: WideString;
  end;

var
  SpellCheckForm: TSpellCheckForm;

implementation

{$R *.dfm}

procedure TSpellCheckForm.Add(const Word: WideString);
begin
  Box.Items.Add(Word);
end;

procedure TSpellCheckForm.FormShow(Sender: TObject);
begin
  FLastWasEdit := True;
  Edit.SetFocus;
  ChangeButton.Enabled := Box.Items.Count > 0;
  if Box.Items.Count = 0 then
  begin
    Box.Enabled := False;
    Box.Items.Add('<Keine Vorschlge>');
  end else
  begin
    Box.Enabled := True;
    Box.Itemindex := 0;
  end;
end;

procedure TSpellCheckForm.Init(const Word: WideString);
begin
  Edit.Text := Word;
  Box.Items.Clear;
end;

function TSpellCheckForm.Replacer: WideString;
begin
  if FLastWasEdit then
    Result := Edit.Text
  else
    if Box.ItemIndex = -1 then
      Result := ''
    else
      Result := Box.Items[Box.ItemIndex];
end;

procedure TSpellCheckForm.BoxClick(Sender: TObject);
begin
  FLastWasEdit := False;
end;

procedure TSpellCheckForm.BoxDblClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TSpellCheckForm.EditChange(Sender: TObject);
begin
  FLastWasEdit := True;
end;

end.
